/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name : FlightSchedule.h                                         */
/*                                                                       */
/*       Date : February 15, 1997                                        */
/* Updated at : February 15, 1997                                        */
/*                                                                       */
/*     Author : H. Timucin OZDEMIR                                       */
/*                                                                       */
/*************************************************************************/
/*************************************************************************/

#ifndef _FLIGHTSCHEDULE_H
#define _FLIGHTSCHEDULE_H

#include <iostream.h>
#include <iomanip.h>

#include <gVector.h>
#include "City.h"
#include "Flight.h"

class FlightSchedule {

  public :

     FlightSchedule() 
     { 
	    schedule = new gVector<Flight>();

     }; // end of CONSTRUCTOR 

     ~FlightSchedule() { delete schedule; };

     int addFlight(Flight ele) 
     { 
        int i;
        int add = 1;
        Flight *i_ele;

	    for(i=0; add && i<schedule->getSize();i++)
	    { 
            i_ele = schedule->getElement(i);

            if(i_ele!=NULL)
            {  
               if( ele==*i_ele) add=0;
               //else cout << ele  << endl
               //          << " differs from " << endl 
               //          << *i_ele << endl;

            }// end of if

        }// end of for
 
        if(add) schedule->addElement(ele);  
      
        return add;

     };

     Flight* getFlightWithIndex(int indx) 
     { return schedule->getElement(indx);  };

     getNumberOfFlights() { return schedule->getSize(); };

     void sort()
     {
	Flight *i_ele;
	Flight *j_ele;
	int i, j;

	cout << " schedule->getSize() " << schedule->getSize() << endl;

	for(i=0;i<schedule->getSize()-1;i++)
          for(j=i+1;j<schedule->getSize();j++)
          {
	     i_ele = schedule->getElement(i);
	     j_ele = schedule->getElement(j);

	     if( i_ele!=NULL && j_ele!=NULL && 
		 i_ele->getDepartureDate()>j_ele->getDepartureDate())
		         schedule->swap(i,j);

          }// end of for

	cout << " schedule->getSize() " << schedule->getSize() << endl;
	for(i=0;i<schedule->getSize();i++)
	{
	   i_ele = schedule->getElement(i);

	   if(i_ele!=NULL) i_ele->setFlightNumber((unsigned)i);

        }// end of for

     };

     //
     void nicePrint(ostream& os)  const
     {
	Flight *i_ele;
	int i;

	os << endl << "            FLIGHT SCHEDULE                   " << endl;
	os << endl << " ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ " << endl;

	for(i=0;i<schedule->getSize();i++)
        {
           i_ele = schedule->getElement(i);
           if(i_ele!=NULL) os << setw(4) << i << " " << *i_ele << endl; 

        }// end of if

     };

     friend ostream& operator<<(ostream& os, const FlightSchedule& RHS)
     { 
        RHS.nicePrint(os);
        return os;
     };

  private :

     gVector<Flight> *schedule;

}; // end of Class FlightSchedule

#endif 
